import { useEffect } from 'react';

declare const useIsomorphicEffect: typeof useEffect;

declare function usePrevious<T>(state: T): T | undefined;

declare function usePreviousDistinct<T>(value: T, compare?: (prev: T | undefined, next: T) => boolean): T | undefined;

interface EventEmitter$1 {
    on: (type: string, listener: () => void) => void;
    off: (type: string, listener: () => void) => void;
}
declare function useBusinessState<E extends EventEmitter$1, R>(emitter: E, events: string[], evalFn: (emitter: E) => R): R;
declare function useBusinessState<E extends EventEmitter$1, A extends unknown[], R>(emitter: E, events: string[], evalFn: (emitter: E, args: [...A]) => R, args: [...A]): R;

interface EventEmitter {
    on: (type: string, listener: () => void) => void;
    off: (type: string, listener: () => void) => void;
}
declare function useBusinessEvent<E extends EventEmitter>(emitter: E, events: string[], listener: (emitter: E) => void): void;
declare function useBusinessEvent<E extends EventEmitter, A extends unknown[]>(emitter: E, events: string[], listener: (emitter: E, args: [...A]) => void, args: [...A]): void;

/**
 * @deprecated useBusiness is deprecated and will be removed in the next major version，please use use useBusinessState instead.
 */
declare const useBusiness: typeof useBusinessState;

export { useBusiness, useBusinessEvent, useBusinessState, useIsomorphicEffect, usePrevious, usePreviousDistinct };
