"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  useBusiness: () => useBusiness,
  useBusinessEvent: () => useBusinessEvent,
  useBusinessState: () => useBusinessState,
  useIsomorphicEffect: () => useIsomorphicEffect,
  usePrevious: () => usePrevious,
  usePreviousDistinct: () => usePreviousDistinct
});
module.exports = __toCommonJS(src_exports);

// src/use-isomorphic-effect.ts
var import_react = require("react");
var useIsomorphicEffect = typeof window === "undefined" ? import_react.useEffect : import_react.useLayoutEffect;

// src/use-previous.ts
var import_react2 = require("react");
function usePrevious(state) {
  const ref = (0, import_react2.useRef)();
  (0, import_react2.useEffect)(() => {
    ref.current = state;
  });
  return ref.current;
}

// src/use-previous-distinct.ts
var import_react3 = require("react");
function usePreviousDistinct(value, compare = (prev, next) => prev === next) {
  const mountedRef = (0, import_react3.useRef)(false);
  const previousRef = (0, import_react3.useRef)();
  const currentRef = (0, import_react3.useRef)(value);
  if (mountedRef.current && !compare(currentRef.current, value)) {
    previousRef.current = currentRef.current;
    currentRef.current = value;
  }
  mountedRef.current = true;
  return previousRef.current;
}

// src/use-business-state.ts
var import_react4 = require("react");
var import_fast_equals = require("fast-equals");
var SEPARATOR = "__@.@__";
function useBusinessState(emitter, events, evalFn, args) {
  const eventStr = events.join(SEPARATOR);
  const subscribe = (0, import_react4.useCallback)(
    (listener) => {
      const types = eventStr.split(SEPARATOR);
      types.forEach((type) => {
        emitter.on(type, listener);
      });
      return () => {
        types.forEach((type) => {
          emitter.off(type, listener);
        });
      };
    },
    [emitter, eventStr]
  );
  const evalFnRef = (0, import_react4.useRef)(evalFn);
  evalFnRef.current = evalFn;
  const argsRef = (0, import_react4.useRef)(args);
  argsRef.current = args;
  const currentValueRef = (0, import_react4.useRef)();
  const getSnapshot = (0, import_react4.useCallback)(() => {
    const nextValue = evalFnRef.current(emitter, argsRef.current);
    const currentValue = currentValueRef.current;
    currentValueRef.current = (0, import_fast_equals.deepEqual)(nextValue, currentValue) ? currentValue : nextValue;
    return currentValueRef.current;
  }, [emitter]);
  return (0, import_react4.useSyncExternalStore)(subscribe, getSnapshot);
}

// src/use-business-event.ts
var import_react5 = require("react");
var SEPARATOR2 = "__@.@__";
function useBusinessEvent(emitter, events, listener, args) {
  const listenerRef = (0, import_react5.useRef)(listener);
  listenerRef.current = listener;
  const argsRef = (0, import_react5.useRef)(args);
  argsRef.current = args;
  const eventStr = events.join(SEPARATOR2);
  useIsomorphicEffect(() => {
    const listenerFn = () => {
      listenerRef.current(emitter, argsRef.current);
    };
    const types = eventStr.split(SEPARATOR2);
    types.forEach((type) => {
      emitter.on(type, listenerFn);
    });
    return () => {
      types.forEach((type) => {
        emitter.off(type, listenerFn);
      });
    };
  }, [emitter, eventStr]);
}

// src/use-business.ts
var deprecated = (fn, message) => {
  let warned = false;
  const wrapped = (...args) => {
    if (!warned) {
      console.warn(message);
      warned = true;
    }
    return fn(...args);
  };
  return wrapped;
};
var useBusiness = deprecated(
  useBusinessState,
  "useBusiness is deprecated and will be removed in the next major version, please use useBusinessState instead."
);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  useBusiness,
  useBusinessEvent,
  useBusinessState,
  useIsomorphicEffect,
  usePrevious,
  usePreviousDistinct
});
